Attribute VB_Name = "Module1"
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source !

Option Explicit

Private Declare Function SetTimer Lib "user32" (ByVal hWnd As _
        Long, ByVal nIDEvent As Long, ByVal uElapse As Long, _
        ByVal lpTimerFunc As Long) As Long

Private Declare Function KillTimer Lib "user32" (ByVal hWnd As _
        Long, ByVal nIDEvent As Long) As Long

Private Declare Function FindFirstChangeNotification _
       Lib "kernel32" Alias "FindFirstChangeNotificationA" _
       (ByVal lpPathName As String, ByVal bWatchSubtree _
       As Long, ByVal dwNotifyFilter As Long) As Long
             
Private Declare Function FindNextChangeNotification Lib _
        "kernel32" (ByVal hChangeHandle As Long) As Long
       
Private Declare Function FindCloseChangeNotification _
        Lib "kernel32" (ByVal hChangeHandle As Long) _
        As Long

Private Declare Function WaitForSingleObject Lib "kernel32" _
        (ByVal hHandle As Long, ByVal dwMilliseconds As _
        Long) As Long
              
Const FILE_NOTIFY_CHANGE_ATTRIBUTES = &H4
Const FILE_NOTIFY_CHANGE_DIR_NAME = &H2
Const FILE_NOTIFY_CHANGE_FILE_NAME = &H1
Const FILE_NOTIFY_CHANGE_LAST_WRITE = &H10
Const FILE_NOTIFY_CHANGE_SECURITY = &H100
Const FILE_NOTIFY_CHANGE_SIZE = &H8

Const INVALID_HANDLE_VALUE = -1
Const WAIT_OBJECT_0 = 0
 
Public TimerEnabled As Boolean

Dim hTimer As Long, hFile As Long, SubDirs As Long
Dim WatchPath As String
Dim Flag As Boolean, Started As Boolean

Public Sub Init(Path As String, SubTrees As Boolean)
    SubDirs = IIf(SubTrees, 1, 0)
    WatchPath = Path & Chr$(0)
    Flag = False
    Started = False
    hFile = 0
   
    'Timer initialisieren
    hTimer = SetTimer(0, 0, 100&, AddressOf TimerProc)
    TimerEnabled = True
End Sub

Public Sub Terminate()
    'Wenn die berwachung noch luft, dann jetzt beenden
    If hFile <> 0 Then Call FindCloseChangeNotification(hFile)
    
    'Timer entfernen
    Call KillTimer(0, hTimer)
    TimerEnabled = False
End Sub

Private Sub TimerProc(ByVal hWnd&, ByVal Msg&, ByVal idEvent&, _
                      ByVal dwTime&)
    
    If Not Flag Then
        'Flag setzen damit weitere TimerEvents nicht in die
        'Quere kommen
        Flag = True
        
        'Schaun ob berwachung gestartet wurde
        If Not Started Then
            
            'Nein, daher erstmal ein Handle fr die berwachung holen.
            'FILE_NOTIFY_CHANGE_FILE_NAME gibt hierbei den berwach-
            'ungstyp an, d.h. es wird auf nderungen mit Dateinamen
            'gelauscht. Werden weitere gewnscht, so kann dieser
            'Parameter mit durch Veroderung der entsprechenden Flags
            'erweitert werden.
            hFile = FindFirstChangeNotification(WatchPath, SubDirs, _
                                     FILE_NOTIFY_CHANGE_FILE_NAME)
            
            'Lieg alles glatt dann ein Flag setzen um beim nchsten
            'TimerEvent an anderer Stelle fortzufahren
            If hFile <> INVALID_HANDLE_VALUE Then Started = True
            
        Else
        
            'Mal schaun ob was anliegt und ein bissel warten um die
            'nderungen wirksam werden su lassen
            If WaitForSingleObject(hFile, 50) = WAIT_OBJECT_0 Then
            
                'Benachrichtigung des Anwenders
                Form1.List1.AddItem Now
                Beep
            End If
            
            'Mal gucken ob's noch weitere Dateien werden, deshalb die
            'berwachung fortsetzen.
            Call FindNextChangeNotification(hFile)
            
            'Alles in Ordnung?
            If hFile = 0 Then
                
                'Ups, da lag ein Fehler vor, besser mal die berwachung
                'schlieen.
                Call FindCloseChangeNotification(hFile)
                Started = False
            End If
        End If
    
        'Timer Events wieder zum Verarbeiten zulassen
        Flag = False
    End If
End Sub
